SystemOrganization addCategory: #'Pier-TagCloud'!

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:21'!
descriptionMenuTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:21'!
descriptionNameTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:20'!
descriptionTagsTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:20'!
descriptionTitleTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:09'!
tagsUsing: aCollection
	"Answer a list of tags using the given aCollection of descriptions."
	
	^ aCollection
		inject: OrderedCollection new
		into: [ :collection :each |
			collection addAll: ((each toString: (self readUsing: each))
				findTokens: ' ').
			collection ]! !

!PRCase class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:19'!
descriptionPlainTextTagCloud: aDescription
	^ aDescription beTagCloud! !

!MADescription methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:22'!
beTagCloud
	self propertyAt: #tagCloud put: true! !

!MADescription methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:22'!
isTagCloud
	^ self propertyAt: #tagCloud ifAbsent: [ false ]! !

PRWidget subclass: #PRTagCloudWidget
	instanceVariableNames: 'tagsByCount'
	classVariableNames: 'StopWords'
	poolDictionaries: ''
	category: 'Pier-TagCloud'!

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 9/13/2007 10:32'!
descriptionDataDescriptions
	| optionsAndLabels |
	optionsAndLabels := Dictionary new.
	PRStructure withAllSubclassesDo: [ :class |
		class description do: [ :each |
			each isTagCloud
				ifTrue: [ optionsAndLabels at: each put: each label ] ] ].
	^ MAMultipleOptionDescription new
		optionsAndLabels: optionsAndLabels associations;
		selectorAccessor: #dataDescriptions;
		default: optionsAndLabels keys;
		priority: 220;
		label: 'Data';
		beDistinct;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 9/13/2007 10:30'!
descriptionMaxItems
	^ MANumberDescription new
		selectorAccessor: #maxItems;
		label: 'Max Items';
		priority: 220;
		default: 50;
		beInteger;
		min: 1;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 9/13/2007 10:32'!
descriptionShowFrequencies
	^ MABooleanDescription new
		selectorAccessor: #showFrequencies;
		checkboxLabel: 'Frequencies';
		default: false;
		label: 'Show';
		priority: 230;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 9/12/2007 22:22'!
descriptionStructure
	^ PRStructureDescription new
		selectorAccessor: #startAt;
		label: 'Start At';
		priority: 200;
		yourself! !

!PRTagCloudWidget class methodsFor: 'initialization' stamp: 'lr 9/13/2007 11:15'!
initialize
	StopWords := Set withAll: #('about' 'an' 'and' 'are' 'as' 'at' 'be' 'by' 'com' 'de' 'en' 'for' 'from' 'he' 'her' 'hers' 'herself' 'him' 'himself' 'how' 'in' 'is' 'it' 'its' 'itself' 'la' 'me' 'mine' 'my' 'myself' 'of' 'on' 'oneself' 'or' 'our' 'ours' 'ourselves' 'she' 'that' 'the' 'their' 'theirs' 'them' 'themselves' 'these' 'they' 'this' 'those' 'to' 'und' 'us' 'was' 'we' 'what' 'when' 'where' 'who' 'will' 'with' 'www' 'you' 'your' 'yours' 'yourself' 'yourselves' )! !

!PRTagCloudWidget class methodsFor: 'testing' stamp: 'lr 9/12/2007 22:55'!
isAbstract
	^ false! !

!PRTagCloudWidget class methodsFor: 'accessing' stamp: 'lr 9/12/2007 22:54'!
label
	^ 'Tag Cloud'! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/12/2007 22:32'!
enumerator
	"Answer an enumerator to visit the necessary structures to collect the tags."
	
	^ (self context enumeratorFor: self structure) with all! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 9/13/2007 11:09'!
renderContentOn: html
	| min max diff |
	self tagsByCount isEmpty ifTrue: [ ^ self ].
	min := self tagsByCount first value size.
	max := self tagsByCount last value size.
	(diff := max - min) isZero 
		ifTrue: [ diff := 1 ]. 
	self tagsByName 
		do: [ :assoc |
			html span class: 'tag'; with: [
				html anchor
					callback: [ self show: assoc value asSet ];
					style: 'font-size: ' , (assoc value size - min * 100 / diff + 100)
						truncated asString , '%';
					with: assoc key.
				(self read: #descriptionShowFrequencies) ifTrue: [
					html span class: 'freq'; with: [
						html space; text: '('; render: assoc value size; text: ')' ] ] ] ]
		separatedBy: [ html text: ' ' ]! !

!PRTagCloudWidget methodsFor: 'actions' stamp: 'lr 9/12/2007 23:18'!
show: aCollection
	aCollection size = 1
		ifTrue: [ ^ self context: (self context structure: aCollection atRandom) ].
	self inform: [ :html |
		html unorderedList: [
			aCollection do: [ :each |
				html listItem: [
					html anchor
						callback: [ 
							self context: (self context structure: each).
							self home ];
						with: each title ] ] ] ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/12/2007 22:23'!
structure
	"Answer the structure where the search for the tag cloud should start from."
	
	^ (self read: #descriptionStructure) ifNil: [ self context structure ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/13/2007 11:09'!
tagsByCount
	"Answer a dictionary mapping tags to structures. The tags are sorted by count."
	
	| map sorted |
	tagsByCount isNil ifFalse: [ ^ tagsByCount ].
	map := Dictionary new.
	self enumerator do: [ :struct |
		(self read: #descriptionDataDescriptions) do: [ :description |
			(self tokenize: struct using: description) do: [ :tag |
				(map at: tag ifAbsentPut: [ OrderedCollection new ])
					add: struct ] ] ].
	sorted := SortedCollection sortBlock: [ :a :b | a value size < b value size ].
	map associationsDo: [ :assoc | sorted add: assoc ].
	^ tagsByCount := (self read: #descriptionMaxItems) isNil
		ifFalse: [ sorted asArray last: (sorted size min: (self read: #descriptionMaxItems)) ]
		ifTrue: [ sorted asArray ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/13/2007 10:56'!
tagsByName
	"Answer the tags alphabetically sorted by name."
	
	^ self tagsByCount asSortedCollection: [ :a :b | a key < b key ]! !

!PRTagCloudWidget methodsFor: 'private' stamp: 'lr 9/13/2007 11:14'!
tokenize: anObject using: aDescription
	| string tokens |
	(aDescription accessor canRead: anObject)
		ifFalse: [ ^ #() ].
	string := aDescription toString: (anObject readUsing: aDescription).
	string := string collect: [ :each | 
		each isLetter
			ifTrue: [ each asLowercase ]
			ifFalse: [ $  ] ].
	tokens := string findTokens: ' '.
	^ tokens reject: [ :each | each size = 1 or: [ StopWords includes: each ] ]! !
PRTagCloudWidget initialize!
